/* Copyright (C) 1995 Free Software Foundation, Inc.
This file is part of GNU Fortran libU77 library.

This library is free software; you can redistribute it and/or modify it
under the terms of the GNU Library General Public License as published
by the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

GNU Fortran is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with GNU Fortran; see the file COPYING.LIB.  If
not, write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.  */

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif
#include <sys/types.h>
#include <signal.h>
#include <errno.h>
#include "f2c.h"

/* fixme: bsd, svr1-3 use int, not pid_t */

#ifdef KR_headers
integer G77_kill_0 (pid, signum)
     integer *pid, *signum;
#else
integer G77_kill_0 (const integer *pid, const integer *signum)
#endif
{
#if defined (HAVE_KILL)
  return kill ((pid_t) *pid, *signum) ? errno : 0;
#else
  errno = ENOSYS;
  return -1;
#endif
}
